MXNet R Package
===============
You have find MXNet R Package! The MXNet R packages brings flexible and efficient GPU
computing and state-of-art deep learning to R.

- It enables you to write seamless tensor/matrix computation with multiple GPUs in R.
- It also enables you construct and customize the state-of-art deep learning models in R,
  and apply them to tasks such as image classification and data science challenges.

Sounds exciting? This page contains links to all the related documents on R package.

Get Started
-----------
Checkout the [Installation Guide](../get_started/build.md) contains instructions to install mxnet, and [Tutorials](#tutorials) for examples on how to use mxnet for various tasks.

Tutorials
---------
* [Neural Network with MXNet in Five Minutes](fiveMinutesNeuralNetwork.md)
* [Classify Realworld Images with Pretrained Model](classifyRealImageWithPretrainedModel.md)
* [Handwritten Digits Classification Competition](mnistCompetition.md)
* [Tutorial on NDArray and Symbol](ndarrayAndSymbolTutorial.md)
* [Tutorial on Callback Functions](CallbackFunctionTutorial.md)

Resources
---------
There are several information to get you started
* [Installation Guide](../get_started/build.md) contains instructions to install mxnet.
* [Contributor Guide](http://mxnet.readthedocs.org/en/latest/contribute.html#r-package)
  - The R package section gives various guidelines on how to contribute code, tutorial, rmarkdown examples to mxnet.
  - Your contribution is always welcomed!
